function e = bendingEnergy(p, k, theta_r)
    agl = hingeAngle(p(1:2), p(3:4), p(5:6));
    diff = agl - theta_r;
    e = k / 2 * diff * diff;
end

function agl = hingeAngle(p0, p1, p2)
    v1_3 = [p1-p0; 0];
    v2_3 = [p2-p1; 0];
    tangent = cross(v1_3, v2_3)/dot(v1_3, v2_3);
    agl = atanNew(tangent);
end

function agl = atanNew(x)
    temp = atan(x);
    if temp < 0
        agl = temp + pi;
    else
        agl = temp;
    end
end
