function e = bendingEnergyDG(v, k, theta_r)
    agl = hingeAngleDG(v(1:2), v(3:4));
    diff = agl - theta_r;
    e = k / 2 * diff * diff;
end

function agl = hingeAngleDG(v1, v2)
    v1_3 = [v1; 0];
    v2_3 = [v2; 0];
    tangent = norm(cross(v1_3, v2_3))/dot(v1_3, v2_3);
    agl = atanNew(tangent);
end

function agl = atanNew(x)
    temp = atan(x);
    if temp < 0
        agl = temp + pi;
    else
        agl = temp;
    end
end