function psi = clothBendingPsi(F, k, theta_r)
    y1 = F(1:3);
    y2 = F(4:6);
    y3 = F(7:9);
    norm1 = norm(y1);
    t1 = y1/norm1;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    s = sign(dot(tb, t1));
    theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
    diffTheta = theta - theta_r;
    psi = 0.5 * k * diffTheta * diffTheta;
end