function B = clothCanonicalBasis(F)
    y1 = F(1:3);
    y2 = F(4:6);
    y3 = F(7:9);
    norm1 = norm(y1); norm2 = norm(y2); norm3 = norm(y3);
    t1 = y1/norm1; t2 = y2/norm2; t3 = y3/norm3;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    tau0 = z0 / normz0; tau1 = z1 / normz1;
    tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
    tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
    z = zeros(3,1);
    B = [[tb;z;z],[tau0perp;z;z],[tau1perp;z;z],[z;tb;z],[z;tau0;z],...
        [z;tau0perp;z],[z;z;tb],[z;z;tau1],[z;z;tau1perp]];
end