function H = clothHessian(x, k, theta_r)
    x0 = x(1:3);
    x1 = x(4:6);
    x2 = x(7:9);
    x3 = x(10:12);
    y1 = x1 - x0;
    y2 = x2 - x0;
    y3 = x3 - x0;
    F = deformationGradientCloth(x);
    pk1 = pFpxCloth(x);
    pk1Simp = pfpxClothSimp(x);
    pk1Diff = pk1 - pk1Simp;
    norm1 = norm(y1); norm2 = norm(y2); norm3 = norm(y3);
    t1 = y1/norm1; t2 = y2/norm2; t3 = y3/norm3;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    tau0 = z0 / normz0; tau1 = z1 / normz1;
    tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
    tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
    s = sign(dot(tb, t1));
    theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
    hessF = hessianAnalytical3DCloth(F, k, theta_r, s);
    pfpx = pFpxCloth(x);
    extra = extraTermHessianCloth(x);
    H = pfpx.' * hessF * pfpx + k * (theta - theta_r) * extra;
end