function hess = deformationHessian(jacobian, x, delta)
    dim = length(x);
    hess = [];
    for i = 1:dim
        hess = cat(3, hess, hessian1D(jacobian, x, delta, i));
    end
end

function g = hessian1D(f, x, delta, ii)
    n = length(x);
    z = zeros(n, 1);
    z(ii) =  delta;
    g = (f(x + z) - ...
        f(x - z))/2/delta;
end