% n: number of tests
function avgError = energyEigensys3DTest(n)
    avgError = 0;
    for i = 1:n
        F = rand(6, 1) * 2 - 1;
        k = rand(1) * 2;
        theta_r = rand(1) * pi;
        hess = hessianAnalytical3D(F, k, theta_r);
        [Q, lambda] = energyEigensys3D(F, k, theta_r);
        hessRecons = Q * diag(lambda) * Q.';
        error = norm(hessRecons - hess);
        avgError = error + avgError;
        % fprintf("Reconstructed hessian error %f\n", error);
    end
    avgError = avgError / n;
    fprintf("Reconstructed hessian average error %e\n", avgError);
end