% n: number of tests
function avgError = energyEigensysClothTest(n)
    avgError = 0;
    for i = 1:n
        x = rand(12, 1) * 2 - 1;
        k = rand(1) * 2;
        theta_r = rand(1) * pi;
        hess = clothHessian(x, k, theta_r);
        x0 = x(1:3);
        x1 = x(4:6);
        x2 = x(7:9);
        x3 = x(10:12);
        y1 = x1 - x0;
        y2 = x2 - x0;
        y3 = x3 - x0;
        F = deformationGradientCloth(x);
        pFpx = pFpxCloth(x);
        norm1 = norm(y1); norm2 = norm(y2); norm3 = norm(y3);
        t1 = y1/norm1; t2 = y2/norm2; t3 = y3/norm3;
        z0 = y2 - t1 * t1.'*y2;
        z1 = y3 - t1 * t1.'*y3;
        normz0 = norm(z0); normz1 = norm(z1);
        tb = cross(z0, z1); tb = tb/norm(tb);
        tau0 = z0 / normz0; tau1 = z1 / normz1;
        tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
        tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
        s = sign(dot(tb, t1));
        theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
        [Q, lambda] = energyEigensys3DCloth(F, k, theta_r, s);
        [V, D] = extraTermEigensys(x);
        hessFRecons = Q * diag(lambda) * Q.';
        extraRecons = V * diag(D) * V.';
        hessRecons = pFpx.' * hessFRecons * pFpx + ...
            k * (theta - theta_r) * extraRecons;
        error = norm(hessRecons - hess);
        avgError = error + avgError;
        % fprintf("Reconstructed hessian error %f\n", error);
    end
    avgError = avgError / n;
    fprintf("Reconstructed hessian average error %e\n", avgError);
end