% Using finite difference to compute the gradient of f
% at position pos.
% delta: finite differece delta
function g = energyGradient(f, pos, k, theta_r, delta)
    n = length(pos);
    rang = 1:n;
    func = @(ii) energyGradient1D(f, pos, k, theta_r, delta, ii, n);
    g = arrayfun(func, rang)';
end

function g = energyGradient1D(f, pos, k, theta_r, delta, ii, n)
    z = zeros(n, 1);
    z(ii) =  delta;
    g = (f(pos + z, k, theta_r) - f(pos - z, k, theta_r))/2/delta;
end