% F is 9x1
function G = energyGradientCloth(F, k, theta_r)
    y1 = F(1:3);
    y2 = F(4:6);
    y3 = F(7:9);
    norm1 = norm(y1);
    t1 = y1/norm1;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    tau0 = z0 / normz0; tau1 = z1 / normz1;
    tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
    tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
    s = sign(dot(tb, t1));
    theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
    g = k*(theta - theta_r);
    G = [1/norm1*(dot(y2, t1)/normz0*tau0perp - ...
        dot(y3, t1)/normz1*tau1perp);-tau0perp/normz0;tau1perp/normz1];
    G = G * s * g;
end