function [Q, lambda] = extraTermEigensys(x)
    x0 = x(1:3);
    x1 = x(4:6);
    x2 = x(7:9);
    x3 = x(10:12);
    y1 = x1 - x0;
    y2 = x2 - x0;
    y3 = x3 - x0;
    norm1 = norm(y1); norm2 = norm(y2); norm3 = norm(y3);
    t1 = y1/norm1; t2 = y2/norm2; t3 = y3/norm3;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    tau0 = z0 / normz0; tau1 = z1 / normz1;
    tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
    tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
    s = sign(dot(tb, t1)); z3 = zeros(3, 1);
    theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
    alpha = -4 * (tau0.'*tau1perp) / norm1 / norm1; alpha2 = alpha*alpha;
    beta = 2 * (tau0.'*tau1perp)/norm1; beta2 = beta*beta;
    a1 = t1.'*y3 / norm1/normz1; b1 = 1/normz1;
    a0 = t1.'*y2 / norm1/normz0; b0 = 1/normz0;
    p0 = [(-a1-a0+b1+b0)*t1;(a1+a0)*t1;-b0*t1;-b1*t1];
    p1 = [(-a1+a0+b1-b0)*t1;(a1-a0)*t1;b0*t1;-b1*t1];
    v0 = [tau0;-tau0;z3;z3]; v1 = [tau1;-tau1;z3;z3]; 
    u0 = v0 + v1; u1 = v0 - v1;
    d00 = (p0.' * p0) / (u0.' * u0); d01 = (p0.' * p1) / (u1.' * u1);
    d10 = (p0.' * p1) / (u0.' * u0); d11 = (p1.' * p1) / (u1.' * u1);
    coeff = [1, 0, -alpha2 - beta2*(d11+d00), beta2*alpha*(d00-d11),...
        beta2*beta2*(d11*d00 - d10*d01)];
    coeff0 = [-alpha2 - beta2*(d11+d00), beta2*alpha*(d00-d11),...
        beta2*beta2*(d11*d00 - d10*d01)];
    lambda = roots(coeff);
    %lambda = solveDepressedQuartic(coeff0);
    if isempty(lambda)
        Q=[];
        return
    end
    fs = beta./lambda; es = (1 ./fs./fs - d00 + alpha/beta./fs)/d10;
    Q = u0 * ones(1, 4) + u1 * es.' + p0 * fs.' + p1 * (es.*fs).';
    for i = 1:4
        Q(:, i) = Q(:, i) / norm(Q(:, i));
    end
    lambda = -s * lambda;
end