function extra = extraTermHessianCloth(x)
    x0 = x(1:3);
    x1 = x(4:6);
    x2 = x(7:9);
    x3 = x(10:12);
    y1 = x1 - x0;
    y2 = x2 - x0;
    y3 = x3 - x0;
    norm1 = norm(y1); norm2 = norm(y2); norm3 = norm(y3);
    t1 = y1/norm1;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    tau0 = z0 / normz0; tau1 = z1 / normz1;
    tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
    tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
    s = sign(dot(tb, t1));
    z33 = zeros(3,3); z3 = zeros(3,1);
    %building blocks
    t1tau0perp = t1 * tau0perp.'; t1tau1perp = t1 * tau1perp.';
    tau0pSigmapx = 1/norm1 * [t1tau0perp, -t1tau0perp, z33, z33];
    tau1pSigmapx = 1/norm1 * [t1tau1perp, -t1tau1perp, z33, z33];
    reflect2 = y2 - 2 * t1 * t1.'*y2; reflect3 = y3 - 2 * t1 * t1.'*y3; 
    tau0peta2px = 1 / norm1 / norm1 *...
    ([reflect2*tau0perp.', -reflect2*tau0perp.', z33, z33] -...
     tau0perp * ([-reflect2 - y1; reflect2; y1; z3].'));
    tau1peta3px = 1 / norm1 / norm1 *...
    ([reflect3*tau1perp.', -reflect3*tau1perp.', z33, z33] -...
     tau1perp * ([-reflect3 - y1; reflect3; z3; y1;].'));
    extra = -s * [(-tau0peta2px - tau0pSigmapx)/normz0 -...
        (-tau1peta3px - tau1pSigmapx)/normz1;...
        tau0peta2px/normz0 - tau1peta3px/normz1;...
        tau0pSigmapx/normz0; -tau1pSigmapx/normz1];
end