function g = gradientAnalyticalDG(v, k, theta_r)
    perp = [0 1; -1 0];
    v1 = v(1:2);
    v2 = v(3:4);
    [theta, s] = hingeAngleDG(v1, v2);
    gg = s * [perp*v1/dot(v1, v1);-perp*v2/dot(v2, v2)];
    g = k * (theta - theta_r) * gg;
end

function [agl, s] = hingeAngleDG(v1, v2)
    v1_3 = [v1; 0];
    v2_3 = [v2; 0];
    cr = cross(v1_3, v2_3);
    c = cr(3);
    s = sign(c);
    tangent = abs(c)/dot(v1_3, v2_3);
    agl = atanNew(tangent);
end

function agl = atanNew(x)
    temp = atan(x);
    if temp < 0
        agl = temp + pi;
    else
        agl = temp;
    end
end
