% compute the hessian of the bending energy analytically
% returns a 6x6 matrix
function hess = hessianAnalytical3D(F, k, theta_r)
    % the hessian is built from the derivatives of theta
    G = thetaGradient3D(F);
    H = thetaHessian3D(F);
    g0 = G(1:3); g1 = G(4:6);
%     B00 = H(1:3, 1:3); B01 = H(1:3, 4:6);
%     B10 = H(4:6, 1:3); B11 = H(4:6, 4:6);
    % the derivative of the energy with respect to theta
    % this can change with different forms of energy
    % quadratic energy:
    theta = hingeAngleCos3D(F);
    g = k * (theta - theta_r); h = k;
    block = [g0 * g0.', g0 * g1.'; g1 * g0.', g1 * g1.'];
    hess = h * block + g * H;
end