function hess = hessianAnalytical3DCloth(F, k, theta_r, s)
    z0 = F(1:3);
    z1 = F(4:6);
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
    % the hessian is built from the derivatives of theta
    G = thetaGradient3D(F);
    H = thetaHessian3DCloth(F);
    g0 = G(1:3); g1 = G(4:6);
%     B00 = H(1:3, 1:3); B01 = H(1:3, 4:6);
%     B10 = H(4:6, 1:3); B11 = H(4:6, 4:6);
    % the derivative of the energy with respect to theta
    % this can change with different forms of energy
    % quadratic energy:
    g = k * (theta - theta_r); h = k;
    hess = h * G * G.' - s * g * H;
end