function nul = nullSpaceExtraTerm(x)
    x0 = x(1:3);
    x1 = x(4:6);
    x2 = x(7:9);
    x3 = x(10:12);
    y1 = x1 - x0;
    y2 = x2 - x0;
    y3 = x3 - x0;
    norm1 = norm(y1); norm2 = norm(y2); norm3 = norm(y3);
    t1 = y1/norm1; t2 = y2/norm2; t3 = y3/norm3;
    z0 = y2 - t1 * t1.'*y2;
    z1 = y3 - t1 * t1.'*y3;
    normz0 = norm(z0); normz1 = norm(z1);
    tb = cross(z0, z1); tb = tb/norm(tb);
    tau0 = z0 / normz0; tau1 = z1 / normz1;
    tau0perp = cross(tau0, tb); tau0perp = tau0perp/norm(tau0perp);
    tau1perp = cross(tau1, tb); tau1perp = tau1perp/norm(tau1perp);
    s = sign(dot(tb, t1));
    theta = s * (pi - acos(dot(z0, z1)/normz0/normz1));
    z3 = zeros(3,1);
    alpha = ((t1.' * y3 - norm1)/normz1 - (t1.' * y2 - norm1)/normz0)/...
        (t1.' * y2 / normz0 - t1.' * y3 / normz1);
    a1 = (y2.'*t1 + y3.'*t1 - 3*norm1)/(y2.'*t1 + y3.'*t1 + norm1);
    a2 = (-3*y2.'*t1 + y3.'*t1 + norm1)/(y2.'*t1 + y3.'*t1 + norm1);
    a3 = (y2.'*t1 - 3*y3.'*t1 + norm1)/(y2.'*t1 + y3.'*t1 + norm1);
    nul = [[tau0;tau0;z3;z3], [tau0perp;tau0perp;z3;z3],...
        [z3;z3;tau0;z3], [z3;z3;tau0perp;z3],...
        [z3;z3;z3;tau0], [z3;z3;z3;tau0perp],...
        [t1;t1;t1;t1], [t1;a1*t1;a2*t1;a3*t1]];
end