% solves x^4 + a x^2 + b x + c
function r = solveDepressedQuartic(coeff)
    a = coeff(1); b = coeff(2); c = coeff(3);
    e = 2*a.^3 + 27 * b.^2 - 72*a.*c;
    f = a.^2 + 12*c;
    if -4*f.^3+e.^2 < 0
        disp('negative sqrt.');
        r=[];
        return
    end
    sq = sqrt(-4*f.^3+e.^2);
    cb = nthroot(e + sq, 3); cbrt2 = nthroot(2, 3);
    cb1 = cbrt2 * f ./ cb/3;
    cb2 = cb / 3 / cbrt2; cbSum = cb1 + cb2;
    t1 = sqrt(-2/3 * a + cbSum); t2 = -4/3 * a -cbSum;
    r = [1/2*(t1 - sqrt(t2 - 2*b/t1));
         1/2*(t1 + sqrt(t2 - 2*b/t1));
         1/2*(t1 - sqrt(t2 + 2*b/t1));
         1/2*(t1 + sqrt(t2 + 2*b/t1))];
end