
% n: Number of tests
% dim: dimension of position vector
% fAnalytical: the function for computing the analytical derivative
% fNumerical: the function for computing the numerical derivative
% Phi: the bending energy function
function testDerivativeNumerical(fAnaly, fNum, Phi, delta, dim, n, thresh)
    avgError = 0;
    for i = 1:n
        pos = rand(dim, 1) * 2 - 1;
        k = rand(1);
        theta_r = rand(1) * pi;
        analytical = fAnaly(pos, k, theta_r);
        numerical = fNum(Phi, pos, k, theta_r, delta);
        error = norm(numerical - analytical)/n / n;
        avgError = avgError + error;
        if error > thresh
            fprintf("large error %e.\n", error);
        end
    end
    avgError = avgError / n;
    fprintf("average error %e.\n", avgError);
end