numTests = 20;
fprintf("--------------------------------------\n");
fprintf("Number of test cases for each test: %d\n", numTests);
fprintf("--------------------------------------\n\n");

fprintf(strcat("--------------------------------------\n",...
               "- 2D Tests\n",...
               "--------------------------------------\n\n"));

% Testing the analytical derivatives of the quadratic energy
% by comparing the analytical results to finite difference.

fprintf("Testing the gradient of 2D quadratic energy.\n")
testDerivativeNumerical(@gradientAnalyticalDG, @energyGradient, ...
    @bendingEnergyDG, 1e-8, 4, numTests, 1e-4);
fprintf("\n");

fprintf("Testing the hessian of 2D quadratic energy.\n")
testDerivativeNumerical(@hessianAnalyticalDG, @energyHessian, ...
    @bendingEnergyDG, 1e-5, 4, numTests, 1e-4);
fprintf("\n");

% Testing the 2D eigensystem
fprintf("Testing the analytical eigensystem of 2D theta Hessian.\n")
thetaEigensys2DTest(numTests);
fprintf("\n");
fprintf("Testing the analytical eigensystem of 2D energy Hessian.\n")
energyEigensys2DTest(numTests);
fprintf("\n");

fprintf(strcat("--------------------------------------\n",...
               "- 3D Tests\n",...
               "--------------------------------------\n\n"));

% Testing the analytical derivatives of theta
% by comparing the analytical results to finite difference.

fprintf("Testing the gradient of 3D theta.\n")
testDerivativeNumerical(@thetaGradient3D, @energyGradient, ...
    @hingeAngleCos3D, 1e-8, 6, numTests, 1e-6);
fprintf("\n");

fprintf("Testing the hessian of 3D theta.\n")
testDerivativeNumerical(@thetaHessian3D, @energyHessian, ...
    @hingeAngleCos3D, 1e-5, 6, numTests, 1e-4);
fprintf("\n");

% Testing the analytical derivatives of the quadratic energy
% by comparing the analytical results to finite difference.

fprintf("Testing the hessian of the 3D quadratic energy.\n")
testDerivativeNumerical(@hessianAnalytical3D, @energyHessian, ...
    @quadraticEnergy3D, 1e-5, 6, numTests, 1e-4);
fprintf("\n");

% Testing the 3D eigensystem
fprintf("Testing the eigensystem of 3D theta Hessian.\n")
thetaEigensys3DTest(numTests);
fprintf("\n");
fprintf("Testing the analytical eigensystem of 3D energy Hessian.\n")
energyEigensys3DTest(numTests);
fprintf("\n");

fprintf(strcat("--------------------------------------\n",...
               "- Cloth Tests\n",...
               "--------------------------------------\n\n"));
fprintf("Testing the hessian of cloth quadratic energy.\n")
testDerivativeNumerical(@clothHessian, @energyHessian, ...
    @clothBendingPsiX, 1e-5, 12, numTests, 1e-5);
fprintf("\n");
fprintf("Testing the analytical eigensystem of cloth energy Hessian.\n")
energyEigensysClothTest(numTests);

