% Q: Column based matrix of eigenvectors
% lambda: vector of eigenvalues
function [Q, lambda] = thetaEigensys2D(v, ~, ~)
    v1 = v(1:2);
    v2 = v(3:4);
    P = [0, 1; -1, 0];
    v1perp = P * v1;
    v2perp = P * v2;
    q0 = [v1 + v1perp;0;0]; q0 = q0/norm(q0);
    q1 = [v1 - v1perp;0;0]; q1 = q1/norm(q1);
    q2 = [0;0; v2 + v2perp]; q2 = q2/norm(q2);
    q3 = [0;0; v2 - v2perp]; q3 = q3/norm(q3);
    dot1 = dot(v1, v1);
    dot2 = dot(v2, v2);
    s = crossSign(v1, v2);
    Q = [q0, q1, q2, q3];
    lambda = [-s/dot1; s/dot1; s/dot2; -s/dot2];
end

function s = crossSign(v1, v2)
    v1_3 = [v1; 0];
    v2_3 = [v2; 0];
    cr = cross(v1_3, v2_3);
    c = cr(3);
    s = sign(c);
end