% n: number of tests
function avgError = thetaEigensys2DTest(n)
    avgError = 0;
    for i = 1:n
        v = rand(4, 1) * 2 - 1;
        hess = thetaHessianDG(v);
        [Q, lambda] = thetaEigensys2D(v);
        hessRecons = Q * diag(lambda) * Q.';
        error = norm(hessRecons - hess);
        avgError = error + avgError;
        % fprintf("Reconstructed hessian error %f\n", error);
    end
    avgError = avgError / n;
    fprintf("Reconstructed hessian average error %e\n", avgError);
end