% n: number of tests
function avgError = thetaEigensys3DTest(n)
    avgError = 0;
    for i = 1:n
        F = rand(6, 1) * 2 - 1;
        hess = thetaHessian3D(F);
        [Q, lambda] = thetaEigensys3D(F);
        hessRecons = Q * diag(lambda) * Q.';
        error = norm(hessRecons - hess);
        avgError = error + avgError;
    end
    avgError = avgError / n;
    fprintf("Reconstructed hessian average error %e\n", avgError);
end