% Compute the gradient of theta analytically
% Returns a 6x1 vector
% F: 6x1
function G = thetaGradient3D(F, ~, ~)
    e0 = F(1:3); e1 = F(4:6); 
    crs = cross(e0, e1);
    n = crs / norm(crs);
    e0perp = cross(e0, n);
    e1perp = cross(e1, n);
    g0 = e0perp / dot(e0, e0);
    g1 = -e1perp / dot(e1, e1);
    G = [g0;g1];
end

