function hess = thetaHessianDG(v, ~, ~)
    perp = [0 1; -1 0];
    v1 = v(1:2);
    v2 = v(3:4);
    s = crossSign(v1, v2);
    dot1 = dot(v1, v1);
    dot2 = dot(v2, v2);
    p2ThetaPV12 = (perp * dot1 - 2 * perp * (v1 * v1.'))/dot1/dot1 * s;
    p2ThetaPV22 = -(perp * dot2 - 2 * perp * (v2 * v2.'))/dot2/dot2 * s;
    block1 = p2ThetaPV12;
    block2 = p2ThetaPV22;
    hess = [block1 zeros(2); zeros(2) block2];
end

function s = crossSign(v1, v2)
    v1_3 = [v1; 0];
    v2_3 = [v2; 0];
    cr = cross(v1_3, v2_3);
    c = cr(3);
    s = sign(c);
end